SELECT
  O.OrderID,
  O.CustomerID,
  D.ProductID,
  D.UnitPrice
FROM
  Orders O
  LEFT JOIN  
  (SELECT
    O.OrderID,
    O.CustomerID,
    D.ProductID,
    D.UnitPrice
  FROM
    Orders O
    LEFT JOIN [Order Details] D ON D.OrderID=O.OrderID 
  WHERE
    O.ShipCountry='Brazil' AND 
      ProductID IN (30,4)
  ) D ON D.OrderID=O.OrderID 
WHERE
  O.ShipCountry='Brazil' 

